#include "mimicwin.h"
#include "ui_mimicwin.h"

using std::cout;
using std::endl;

MimicWin::MimicWin(QWidget *parent)
    : QMainWindow(parent), ui(new Ui::MimicWin)
{
	arm = new ARMachine();
	ARMinstruction inst;

    ui->setupUi(this);

	ui->opcodeText->setText(QString::number(0xe1a0c00d, 16));
	inst.Decode(0xe1a0c00d);

	try {
		arm->Execute(inst);
		UpdateWindow();
	}
	catch(const MimicException& e) {
		cout << e.n << ":" << e.r << endl;
		exit(1);
	}
}

MimicWin::~MimicWin()
{
    delete ui;
	delete arm;
}

void MimicWin::UpdateWindow()
{
	// 범용 레지스터 값 갱신
	ui->r0Text->setText(QString::number(arm->r[0], 16));
	ui->r1Text->setText(QString::number(arm->r[1], 16));
	ui->r2Text->setText(QString::number(arm->r[2], 16));
	ui->r3Text->setText(QString::number(arm->r[3], 16));
	ui->r4Text->setText(QString::number(arm->r[4], 16));
	ui->r5Text->setText(QString::number(arm->r[5], 16));
	ui->r6Text->setText(QString::number(arm->r[6], 16));
	ui->r7Text->setText(QString::number(arm->r[7], 16));
	ui->r8Text->setText(QString::number(arm->r[8], 16));
	ui->r9Text->setText(QString::number(arm->r[9], 16));
	ui->r10Text->setText(QString::number(arm->r[10], 16));
	ui->r11Text->setText(QString::number(arm->r[11], 16));
	ui->r12Text->setText(QString::number(arm->r[12], 16));
	ui->r13Text->setText(QString::number(arm->r[13], 16));
	ui->r14Text->setText(QString::number(arm->r[14], 16));
	ui->r15Text->setText(QString::number(arm->r[15], 16));
}

void MimicWin::on_btnStepOver_clicked()
{
	ui->debugMessage->appendPlainText(tr("테스트용"));
}
